/**
 * Classe MaFenetre
 * Vers une fenetre plus elaboree...
 * 
 */

import javax.swing.*;
import java.awt.*;   
import java.awt.event.*;     
    
public class MaFenetre extends JFrame 
             implements ObservateurDeCompteur, ActionListener
{
    private JButton bPlus;
    private JButton bMoins;
    private JButton bRaZ;
    private JLabel  etiq;
    private JPanel  jPBoutons;
    
    private JRadioButton jRBPetit;
    private JRadioButton jRBGrand;
    private JPanel       jPRadioBoutons;
    
    private JMenuBar barreMenu;
    private JMenu jMenuFichier;
    private JMenu jMenuEdition;
    private JMenuItem jMenuItemEnreg, jMenuItemQuit;
    private JMenuItem jMenuItemEnregAs;
    
    private JLabel jLTexte1;
    private JComboBox jCBoxChoixCouleur1;
    private JPanel jPListes;
    
    public MaFenetre(int val, MonEcouteur ref)
    {
        setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);
        setBounds(10, 20, 400, 300);
        setTitle("Fenetre principale");
        getContentPane().setLayout(new BorderLayout(10, 10));
        
        this.bPlus = new JButton("Plus");
        this.bPlus.setActionCommand("Plus");
        this.bPlus.setBackground(Color.white);

        this.bMoins = new JButton("Moins");
        this.bMoins.setActionCommand("Moins"); 
        this.bMoins.setBackground(Color.white);        

        this.bRaZ = new JButton("Reset");
        this.bRaZ.setActionCommand("Reset");
        this.bRaZ.setBackground(Color.white);        

        this.etiq = new JLabel(Integer.toString(val), SwingConstants.CENTER);
        this.etiq.setFont(Util.police[0]);
        this.etiq.setForeground(Color.white);
        
        this.bPlus.addActionListener(ref);
        this.bMoins.addActionListener(ref);
        this.bRaZ.addActionListener(ref);
        
        this.jPBoutons = new JPanel(new GridLayout(3, 1, 10, 10));
        this.jPBoutons.add(this.bPlus);
        this.jPBoutons.add(this.bMoins);
        this.jPBoutons.add(this.bRaZ);               
        getContentPane().add(this.jPBoutons, BorderLayout.WEST);
        getContentPane().add(this.etiq, BorderLayout.CENTER);   
        
        this.jRBPetit = new JRadioButton("Petit", true);
        this.jRBGrand = new JRadioButton("Grand", false); 

        ButtonGroup groupeDeBoutons = new ButtonGroup();
        groupeDeBoutons.add(this.jRBPetit);
        groupeDeBoutons.add(this.jRBGrand);
        
        this.jRBPetit.addActionListener(this);
        this.jRBGrand.addActionListener(this);   
        
        this.jPRadioBoutons = new JPanel();
        this.jPRadioBoutons.setBorder(BorderFactory.createLoweredBevelBorder());
        this.jPRadioBoutons.add(this.jRBPetit);
        this.jPRadioBoutons.add(this.jRBGrand);
        getContentPane().add(this.jPRadioBoutons, BorderLayout.SOUTH);       
        
        this.barreMenu = new JMenuBar();
        this.jMenuFichier = new JMenu("Fichier");

        this.jMenuItemEnreg = new JMenuItem("Enregistrer");
        this.jMenuItemEnreg.addActionListener(this);
        this.jMenuFichier.add(this.jMenuItemEnreg);

        this.jMenuItemEnregAs = new JMenuItem("Enregistrer sous...");
        this.jMenuItemEnregAs.addActionListener(this);          
        this.jMenuFichier.add(this.jMenuItemEnregAs);        

        this.jMenuItemQuit = new JMenuItem("Quitter");
        this.jMenuItemQuit.addActionListener(this);  
        this.jMenuFichier.add(this.jMenuItemQuit);

        this.barreMenu.add(this.jMenuFichier);

        this.jMenuEdition = new JMenu("Edition");
        this.barreMenu.add(this.jMenuEdition);

        setJMenuBar(this.barreMenu);
        
        this.jLTexte1 = new JLabel("Choix Couleur Compteur"); 
        this.jLTexte1.setForeground(Color.black);
        this.jCBoxChoixCouleur1 = new JComboBox(Util.nomCouleurTexte);
        this.jCBoxChoixCouleur1.setEditable(false);
        this.jCBoxChoixCouleur1.addActionListener(this);

        this.jPListes = new JPanel();
        this.jPListes.setLayout(new GridLayout(2, 2));
        this.jPListes.add(this.jLTexte1);
        this.jPListes.add(this.jCBoxChoixCouleur1);
        getContentPane().add(this.jPListes, BorderLayout.NORTH);            
    }
    
    public void nouvelleValeur(int val)
    {
        this.etiq.setText(Integer.toString(val));
    }   
    
    public void actionPerformed(ActionEvent e) 
    {   
	Object source = e.getSource();

	if (source == this.jRBPetit) 
	    this.etiq.setFont(Util.police[0]);
        else if (source == this.jRBGrand) 
	    this.etiq.setFont(Util.police[2]);
	else if (source == this.jMenuItemQuit) 
	    System.exit(0);
	else if (source == this.jMenuItemEnreg) 
	    System.out.println("Non operationnel");
	else if (source == this.jMenuItemEnregAs) 
	    System.out.println("Non operationnel");
	else if (source == this.jCBoxChoixCouleur1) 
	    {
		int numCouleur;
		numCouleur = ((JComboBox)source).getSelectedIndex();
		if (0 <= numCouleur) 
		    this.etiq.setForeground(Util.couleurTexte[numCouleur]);
	    }
    }  
    
}
